; ===============================================================================
;
;
;
;		666666   555555   333333   000000
;		6        5             3   0    0
;		6        5             3   0    0
;		666666   555555   333333   0    0
;		6    6        5        3   0    0
;		6    6        5        3   0    0
;		666666   555555   333333   000000
;
;
;		         000000   000000   333333
;		         0    0   0    0        3
;		------   0    0   0    0        3
;		------   0    0   0    0   333333
;		------   0    0   0    0        3
;		         0    0   0    0        3
;		         000000   000000   333333
;
;
;
;
; COPYRIGHT
; MOS TECHNOLOGY, INC
; DATE OCT 18 1975 REV D
;
; 6530-003 IS AN AUDIO CASSETTE TAPE
; RECORDER EXTENSION OF THE BASIC
; KIM MONITOR
;
; IT FEATURES TWO BASIC ROUTINES (WORKING AT 133 BAUD WITH 8 SYMBOLS/CHAR):
; 	LOADT - LOAD MEM FROM AUDIO TAPE
; 	DUMPT - STORE MEM ONTO AUDIO TAPE
;
; LOADT
; 	ID=00		IGNORE ID
; 	ID=FF		IGN. ID, USE SA FOR START ADDR
; 	ID=01-FE	IGN. ID, USE ADDR ON TAPE
;
; DUMPT
;	ID=00		SHOULD NOT BE USED
;	ID=FF		SHOULD NOT BE USED
;	ID=01-FE	NORMAL ID RANGE
;	SAL		LSB OF STARTING ADDRESS
;	SAH		MSB OF STARTING ADDRESS
;	EAL		LSB OF ENDING ADDRESS
;	EAH		MSB OF ENDING ADDRESS
;
;
; ===============================================================================
;
; ---------------------------------------------------------------- PAGE 3 -------
;	EQUATES
;	SET UP FOR 6530-002 I/O, TIMER ONLY USED FOR TAPE DUMP AND LOAD
;
SAD	= $1740		; 6530 A DATA	--> IS READ 9X (605,614,625,649,967,976,1074,1119,1121)
PADD	= $1741		; 6530 A DATA DIRECTION --> IS SET 3X IN CODE (975, 1068, 1110)
SBD	= $1742		; 6530 B DATA	--> IS SET/READ 22X
PBDD	= $1743		; 6530 B DATA DIRECTION	--> IS SET 3X IN CODE (128, 488, 1000)
CLK1T	= $1744		; WRITE DIVIDE BY 1 TIME	--> ONLY USED IN AUDIO TAPE LOADT/DUMPT
CLK8T	= $1745		; WRITE DIVIDE BY 8 TIME	--> NOT USED IN KIM-1 CODE
CLK64T	= $1746		; WRITE DIVIDE BY 64 TIME	--> ONLY USED IN AUDIO TAPE LOADT/DUMPT
CLKKT	= $1747		; WRITE DIVIDE BY 1024 TIME	--> NOT USED IN KIM-1 CODE
CLKRDI	= $1747		; READ TIMEOUT BIT
CLKRDT	= $1746		; READ TIME
;
	*=$00EF
;	MPU REG. SAVE AREA IN PAGE 0
;
PCL	*=*+1		; PROGRAM COUNTER LOW
PCH	*=*+1		; PROGRAM COUNTER HIGH
PREG	*=*+1		; STATUS REGISTER
SPUSER	*=*+1		; STACK POINTER USER
ACC	*=*+1		; ACCUMULATOR
YREG	*=*+1		; Y INDEX
XREG	*=*+1		; X INDEX
;
;	KIM-1 FIXED RAM AREA IN PAGE 0
;
CHKHI	*=*+1		; CHECKSUM FOR PAPERTAPE LOAD/DUMP
CHKSUM	*=*+1		; CHECKSUM FOR PAPERTAPE LOAD/DUMP
INL	*=*+1		; INPUT BUFFER LOW
INH	*=*+1		; INPUT BUFFER HIGH
POINTL	*=*+1		; ADDRESS LOW ON DISPLAY
POINTH	*=*+1		; ADDRESS HI ON DISPLAY
TEMP	*=*+1		; TEMPORARY ACCUMULATOR STORAGE
TMPX	*=*+1		; TEMPORARY X-REGISTER STORAGE
CHAR	*=*+1		; USED FOR RETRIEVING CHARACTER FROM TTY
MODE	*=*+1		; HOLDS ACTUAL KB MODE ($01=ADDRESS MODE, $00=DATA MODE)
;
;	KIM-1 FIXED RAM AREA IN PAGE 23 (6530-002 RAM)
;
	*=$17E7
CHKL	*=*+1		; CHECKSUM LOW FOR PAPERTAPE LOAD/DUMP
CHKH	*=*+1		; CHECKSUM HIGH FOR PAPERTAPE LOAD/DUMP
SAVX	*=*+3		; USED FOR TEMPORARY SAVINGS
VEB	*=*+6		; VOLATILE EXECUTION BLOCK
CNTL30	*=*+1		; TTY DELAY LOW (MEASURED TTY START BIT DURATON)
CNTH30	*=*+1		; TTY DELAY HIGH -> CNTx30 = TYPICALLY 30 CHARS PER SECOND
TIMH	*=*+1		; USED IN TTY DELAY SUBROUTINE
SAL	*=*+1		; LOW STARTING ADDRESS
SAH	*=*+1		; HI STARTING ADDRESS
EAL	*=*+1		; LOW ENDING ADDRESS
EAH	*=*+1		; HI ENDING ADDRESS
ID	*=*+1		; DUMP ID
;
;	INTERRUPT VECTORS
;
NMIV	*=*+2		; STOP VECTOR, MUST!!! BE SET TO STOP = $1C00, SEE USER MANUAL PAGE 45/46
RSTV	*=*+2		; RESET-VECTOR, DEFINED IN ROM WITH $1C22 (KIM ENTRY VIA RESET)
IRQV	*=*+2		; IRQ-VECTOR (ALSO FOR BRK OP-CODE), SHALL BE SET TO E.G. STOP = $1C00, IF USED
;
; ---------------------------------------------------------------- PAGE 5 -------
	*=$1800
;
;	INIT VOLATILE EXECUTION BLOCK
;	DUMP MEMORY TO TAPE
;
DUMPT	LDA	#$AD	; LOAD ABSOLUTE INSTUCTION
	STA	VEB
	JSR	INTVEB
;
	LDA	#$27	; TURN OFF DATAIN PB5
	STA	SBD
	LDA	#$BF	; CONVERT PB7 TO OUTPUT
	STA	PBDD
;
	LDX     #$64    ; 100 CHARS
DUMPT1  LDA     #$16    ; SYNC CHARS
	JSR     OUTCHT
	DEX
	BNE     DUMPT1
;
;
	LDA     #$2A    ; START CHAR
	JSR     OUTCHT
;
	LDA     ID      ; OUTPUT ID
	JSR     OUTBT
;
	LDA     SAL     ; OUTPUT START ADDRESS
	JSR     OUTBTC
	LDA     SAH
	JSR     OUTBTC
;
DUMPT2  LDA     VEB+1   ; COMPARE FOR LAST DATA BYTE
	CMP     EAL
	LDA     VEB+2
	SBC     EAH
	BCC     DUMPT4
;
	LDA     #$2F    ; OUTPUT END OF DATA CHAR
	JSR     OUTCHT
	LDA     CHKL    ; LAST BYTE HAS BEEN
	JSR     OUTBT	; OUT PUT, NOW OUTPUT
	LDA     CHKH
	JSR     OUTBT
;
;
	LDX     #$02    ; 2 CHARS
DUMPT3  LDA     #$04    ; EOT-CHAR
	JSR     OUTCHT
	DEX
	BNE     DUMPT3
; ---------------------------------------------------------------- PAGE 6 -------
	LDA     #$00    ; DISPLAY 0000
	STA     POINTL	; FOR NORMAL EXIT
	STA     POINTH
	JMP     START
;
DUMPT4  JSR     VEB     ;  DATA BYTE OUTPUT DATA
	JSR     OUTBTC
;
	JSR     INCVEB
	JMP     DUMPT2
;
; LOAD MEMORY FROM TAPE
;
;
TAB     .WORD	LOAD12
LOADT   LDA     #$8D    ; INIT VOLATILE EXECUTION
	STA     VEB     ; BLOCK WITH STA ABS
	JSR     INTVEB
;
	LDA     #$4C    ; JUMP TYPE RETURN
	STA     VEB+3
	LDA     TAB
	STA     VEB+4
	LDA     TAB+1
	STA     VEB+5
;
	LDA     #$07	; RESET PB5
	STA     SBD
;
SYNC    LDA     #$FF	; CLEAR SAVX FOR SYNC-AREA
	STA     SAVX
;
SYNC1   JSR     RDBIT   ; GET A BIT
	LSR     SAVX
	ORA     SAVX
	STA     SAVX
	LDA     SAVX    ; GET NEW CHAR
	CMP     #$16    ; SYNC-CHAR?
	BNE     SYNC1
;
	LDX     #$0A    ; TEST FOR 10 SYNC-CHAR
SYNC2   JSR     RDCHT
	CMP     #$16    ; SYNC-CHAR?
	BNE     SYNC
	DEX
	BNE     SYNC2
;
LOADT4  JSR     RDCHT   ; LOOK FOR START OF
	CMP     #$2A    ; START CHAR
	BEQ     LOAD11  ; YES ->
	CMP     #$16    ; SYNC-CHAR?
; ---------------------------------------------------------------- PAGE 7 -------
	BNE     SYNC    ; NO ->
	BEQ     LOADT4  ; ALWAYS ->
;
LOAD11  JSR     RDBYT   ; READ ID
	CMP     ID      ; REQUESTED ID ?
	BEQ     LOADT5  ; YES ->
	LDA     ID
	CMP     #$00    ; IGNORE ID ?
	BEQ     LOADT5  ; YES ->
	CMP     #$FF    ; IGNORE START ADDRESS?
	BEQ     LOADT6  ; YES ->
	BNE     LOADT   ; NEXT PROGRAM, ALWAYS ->
;
LOADT5  JSR     RDBYT   ; GET SA FROM TAPE
	JSR     CHKT
	STA     VEB+1
	JSR     RDBYT
	JSR     CHKT
	STA     VEB+2
	JMP     LOADT7
;
LOADT6  JSR     RDBYT   ; GET SA FROM TAPE
	JSR     CHKT    ; BUT IGNORE
	JSR     RDBYT
	JSR     CHKT
;
;
LOADT7  LDX     #$02
LOAD13  JSR     RDCHT
	CMP     #$2F    ; LAST CHAR?
	BEQ     LOADT8  ; YES ->
	JSR     PACKT   ; CONVERT TO HEX
	BNE     LOADT9  ; Y=1, NON-HEX CHAR
	DEX             ; 2 CHARS?
	BNE     LOAD13  ; NO -> NEXT ONE

	JSR     CHKT    ; COMPUTE CHECKSUM
	JMP     VEB
LOAD12  JSR     INCVEB  ; INCREMENT DATAPOINTER
	JMP     LOADT7
;
LOADT8  JSR     RDBYT   ; EOD COMPARE CHECKSUM
	CMP     CHKL
	BNE     LOADT9
	JSR     RDBYT
	CMP     CHKH
	BNE     LOADT9
	LDA     #$00
	BEQ     LOAD10  ; NORMAL EXIT, ALWAYS ->
LOADT9  LDA     #$FF    ; ERROR EXIT
LOAD10  STA     POINTL
; ---------------------------------------------------------------- PAGE 8 -------
	STA     POINTH
	JMP     START   ; DISPLAY VALUES
;
; ---------------------------------------------------------------- PAGE 9 -------
;
; SUBROUTINES FOLLOWS
;
; SUB TO MOVE SA ADDRESS TO VEB+1,2
;
INTVEB  LDA     SAL
	STA     VEB+1
	LDA     SAH
	STA     VEB+2
	LDA     #$60    ; CODE FOR RTS
	STA     VEB+3
	LDA     #$00
	STA     CHKL
	STA     CHKH
	RTS
;
; COMPUTE CHECKSUM FOR TAPE LOAD
; RTN USES Y to SAVX A
;
CHKT    TAY
	CLC
	ADC     CHKL
	STA     CHKL
	LDA     CHKH
	ADC     #$00
	STA     CHKH
	TYA
	RTS
;
; OUTPUT ONE BYTE USE Y
; TO SAVX BYTE
;
OUTBTC  JSR     CHKT
OUTBT   TAY
	LSR	A
	LSR	A
	LSR	A
	LSR	A
	JSR     HEXOUT  ; OUTPUT MSD
	TYA
	JSR     HEXOUT  ; OUTPUT LSD
	TYA
	RTS
;
; CONVERT LSD OF A TO ASCII
; AND OUTPUT TO TAPE
;
HEXOUT  AND     #$0F
	CMP     #$0A
	CLC
	BMI     HEX1
	ADC     #$07
; ---------------------------------------------------------------- PAGE 10 ------
HEX1    ADC     #$30
; OUTPUT TO TAPE ONE ASCII
; CHAR USE SUB'S ONE + ZRO
;
OUTCHT  STX     SAVX
	STY     SAVX+1
	LDY     #$08    ; STARTBIT
CHT1    JSR     ONE
	LSR     A       ; GET DATA BIT
	BCS     CHT2
	JSR     ONE
	JMP     CHT3
CHT2    JSR     ZRO
CHT3    JSR     ZRO
	DEY             ; ALL BITS?
	BNE     CHT1    ; NO ->
	LDX     SAVX
	LDY     SAVX+1
	RTS
;
;
; OUTPUT 1 TO TAPE
; 9 PULSES 138 MICROSEC EACH
;
ONE     LDX     #$09
	PHA		; SAVX A
ONE1    BIT     CLKRDI  ; WAIT FOR TIMEOUT
	BPL     ONE1
	LDA     #126
	STA     CLK1T
	LDA     #$A7
	STA     SBD     ; PB7 = 1
ONE2    BIT     CLKRDI  ; WAIT FOR TIMEOUT
	BPL     ONE2
	LDA     #126
	STA     CLK1T
	LDA     #$27
	STA     SBD     ; RESET PB7 = 0
	DEX             ; ALL PULSES?
	BNE     ONE1
	PLA		; RESTORE A
	RTS
;
;
; OUTPUT 0 TO TAPE: 6 PULSES 207 MICROSEC EACH
;
ZRO     LDX     #$06
	PHA		; SAVX A
ZRO1    BIT     CLKRDI  ; WAIT FOR TIMEOUT
	BPL     ZRO1
; ---------------------------------------------------------------- PAGE 11 ------
	LDA     #195
	STA     CLK1T
	LDA     #$A7
	STA     SBD     ; SET PB7 = 1
ZRO2    BIT     CLKRDI  ; WAIT FOR TIMEOUT
	BPL     ZRO2
	LDA     #195
	STA     CLK1T
	LDA     #$27
	STA     SBD     ; RESET PB7 = 0
	DEX             ; ALL PULSES ?
	BNE     ZRO1
	PLA		; RESTORE A
	RTS
;
; INCREMENT VEB+1,2
;
INCVEB  INC     VEB+1
	BNE     INCVE1
	INC     VEB+2
INCVE1  RTS
;
; SUB TO READ BYTE FROM TAPE
;
RDBYT   JSR     RDCHT
	JSR     PACKT
RDBYT2  JSR     RDCHT
	JSR     PACKT
	RTS
;
; PACK A=ASCII INTO SAVX AS HEX DATA
;
PACKT   CMP     #$30    ; ASCII ?
	BMI     PACKT3  ; NO ->
	CMP     #$47
	BPL     PACKT3  ; NO ->
	CMP     #$40    ; > '9' ?
	BMI     PACKT1  ; NO ->
	CLC
	ADC     #$09
PACKT1  ROL	A
	ROL	A
	ROL	A
	ROL	A
	LDY     #$04
PACKT2  ROL	A
	ROL     SAVX
	DEY
	BNE     PACKT2
	LDA     SAVX	; AT THIS POINT Y ALREADY IS 0 (= VALID HEX CHAR)
	LDY     #$00    ; SET THE ZERO-FLAG
; ---------------------------------------------------------------- PAGE 12 ------
	RTS		; Y=0 VALID HEX
PACKT3  INY     	; Y=1 -> INVALID HEX CHAR
	RTS
;
; GET 1 CHAR FROM TAPE AND RETURN
; WITH CHAR IN A, USE SAVX+1 TO ASM CHAR
;
RDCHT   STX     SAVX+2
	LDX     #$08	; READ 8 BITS
RDCHT1  JSR     RDBIT	; GET NEXT DATA BIT
	LSR     SAVX+1	; RIGHT SHIFT CHAR
	ORA     SAVX+1	; OR IN SIGN BIT
	STA     SAVX+1;	; REPLACE CHAR
	DEX
	BNE     RDCHT1
;
	LDA     SAVX+1	; MOVE CHAR INTO A
	ROL	A	; SHIFT OFF PARITY
	LSR	A
	LDX     SAVX+2
	RTS
;
; THIS SUB GETS ONE BIT FROM
; TAPE AND RETURNS IT IN SIGN OF A (BIT 7)
;
RDBIT   BIT     SBD     ; WAIT FOR END OF START BIT
	BPL     RDBIT
	LDA     CLKRDT  ; GET START BIT TIME
	LDY     #$FF    ; A = 256 - T1
	STY     CLK64T	; SET UP TIMER
;
	LDY     #$14
RDBIT3  DEY             ; DELAY 100 MICROSEC
	BNE     RDBIT3

RDBIT2  BIT     SBD
	BMI     RDBIT2  ; WAIT FOR NEXT START BIT
;
	SEC
	SBC     CLKRDT	; (256-T1)-(256-T2) = T2-T1
	LDY     #$FF    
	STY     CLK64T	; SET UP TIMJER FOR NEXT BIT
;
	LDY     #$07
RDBIT4  DEY             ; DELAY 50 MICROSEC
	BNE     RDBIT4
;
	EOR     #$FF    ; COMPLEMENT SIGN OF A
	AND     #$80    ; MASK ALL EXCEPT SIGN
	RTS
; ---------------------------------------------------------------- PAGE 13 ------
;
;
; DIAGNOSIC MEMORY
; MEMORY PLLCAL FOR NE565
;
;
;
; PLLCAL OUTPUT 166 MICROSEC PULSE STRING
;
;
PLLCALL LDA     #$27
	STA     SBD     ; TURN OFF DATIN PB5=1
	LDA     #$BF	; CONVERT PB7 TO OUTPUT
	STA     PBDD
;
PLL1    BIT     CLKRDI
	BPL     PLL1
	LDA     #154    ; WAIT 166 MICROSEC
	STA     CLK1T
	LDA     #$A7    ; OUTPUT PB7=1
	STA     SBD
;
PLL2    BIT     CLKRDI
	BPL     PLL2
	LDA     #154
	STA     CLK1T
	LDA     #$27    ; OUTOUT PB7=0
	STA     SBD
	JMP     PLL1	; SHALL RESULT IN ADDRESS AND CODE: 1A93  4C 75 1A
;
; INTERRUPTS IN PAGE 27
;
;	*=*+$0164	; RESERVED FOR TEST
	*=$1BFA		; FOR SECURITY, BETTER TO WRITE: *=$1BFA
NMIP27  .WORD     PLLCALL
RSTP27  .WORD     PLLCALL
IRQP27  .WORD     PLLCALL
;
; ===============================================================================
;
; ---------------------------------------------------------------- PAGE 15 ------
;
;
;
;
;		666666   555555   333333   000000
;		6        5             3   0    0
;		6        5             3   0    0
;		666666   555555   333333   0    0
;		6    6        5        3   0    0
;		6    6        5        3   0    0
;		666666   555555   333333   000000
;
;
;		         000000   000000   222222
;		         0    0   0    0        2
;		------   0    0   0    0        2
;		------   0    0   0    0   222222
;		------   0    0   0    0   2
;		         0    0   0    0   2
;		         000000   000000   222222
;
;
;
;
; COPYRIGHT
; MOS TECHNOLOGY, INC
; DATE OCT 13 1975 REV E
;
; KIM	: TTY INTERFACE
;	: KEYBOARD INTERFACE
;	: 7 SEG 6 DIGIT DISPLAY
;
;
; TTY CMDS:
;	G	GOEXEC
;	CR	OPEN NEXT CLELL
;	LF	OPEN PREV. CELL
;	.	MODIFY OPEN CELL
;	SP	OPEN NEW CELL
;	L	LOAD (OBJECT FORMAT)
;	Q	DUMP FROM OPEN CELL ADDR TO HI LIMIT
;	RO	RUB OUT - RETURN TO START (KIM)
;		((ALL ILLEGAL CHAR ARE IGNORED))
:
; KEYBOARD CMDS:
;	ADDR	(AD) SETS MODE TO MODIFY CELL ADDRESS
;	DATA	(DA) SETS MODE TO MODIFY DATA IN OPEN CELL
;	STEP	(+) INCREMENTS TO NEXT CELL
;	RST	(RS) SYSTEM RESET
;	RUN	(GO) GOEXEC
;	STOP	(ST) $1C00 CAN BE LOADED INTO NMIV TO USE STOP FEATURE
;	PC	(PC) DISPLAY PC
;
;	CLOCK IS NOT DISABLED IN SIGMA 1
;
;
; ===============================================================================
;
;
; ---------------------------------------------------------------- PAGE 16 ------
	*=$1C00
;
;
SAVE    STA     ACC	; KIM ENTRY VIA STOP (NMI) OR BRK (IRQ)
	PLA
	STA     PREG
SAVE1   PLA		; KIM ENTRY VIA JSR (ACCUMULATOR LOST)
	STA     PCL
	STA     POINTL
	PLA
	STA     PCH
	STA     POINTH
SAVE2   STY     YREG
	STX     XREG
	TSX
	STX     SPUSER
	JSR     INITS
	JMP     START
;
NMIT    JMP     (NMIV)	; NON MASKABLE INTERRUPT TRAP, NMIV SHOULD BE SET BY USER TO $1C00
IRQT    JMP     (IRQV)	; INTERRUPT TRAP, SAME AS NMIV, ALSO SEE DECLARATIONS AT THE BEGIN
;
RST	LDX     #$FF	; KIM ENTRY VIA RESET
	TXS             ; SET STACK
	STX     SPUSER
	JSR     INITS
;
; PREPARE TO DETERMINE CHARACTERS PER SECOND IN CASE OF TTY
DETCPS  LDA     #$FF	; COUNT STARTBIT
	STA     CNTH30	; ZERO CNTH30, TEST FIRST KEYBOARD OR TELEPRINTER (TTY)
	LDA     #$01    ; MASK BIT 0
DET1    BIT     SAD     ; TEST FOR TTY (TELETYPE), READ JUMPER
	BNE     START   ; NO ->
	BMI     DET1    ; NO STARTBIT, WAIT FOR IT ->
	LDA     #$FC
DET3    CLC		; THIS LOOP COUNTS STARTBIT TIME
	ADC     #$01    ; A=0 ?
	BCC     DET2    ; NO ->
	INC     CNTH30
DET2    LDY     SAD     ; CHECK FOR END OF STARTBIT
	BPL     DET3    ; NO ->
	STA     CNTL30
	LDX     #$08
	JSR     GET5    ; GET REST OF CHAR, TEST CHAR HERE
; ---------------------------------------------------------------- PAGE 17 ------
;
;
;
;
; MAKE TTY/KB SELECTION
;
;
START   JSR     INIT1
	LDA     #$01	; READ JUMPER
	BIT     SAD	; TTY ?
	BNE     TTYKB	; NO -> KEYBOARD/DISPLAY-ROUTINE
	JSR     CRLF	; PRINT CARRIAGE RETURN / LINE FEED
	LDX     #$0A
	JSR     PRTST   ; PRINT 'KIM'
	JMP     SHOW1
;
CLEAR   LDA     #$00
	STA     INL     ; CLEAR INPUT BUFFER
	STA     INH
READ    JSR     GETCH   ; GET CHAR FROM TTY
	CMP     #$01    ; 1 HAS NO MEANING FOR TTY
	BEQ     TTYKB   ; 1 = KB-MODE ->
	JSR     PACK    
	JMP     SCAN
;
; MAIN ROUTINE FOR KEYBOARD
; AND LED DISPLAY
;
TTYKB   JSR     SCAND   ; WAIT UNTIL NO KEY PRESSED
	BNE     START   ; IF PRESSED, WAIT AGAIN ->
TTYKB1  LDA     #$01    ; CHECK KB/TTY MODE
	BIT     SAD     ; TTY?
	BEQ     START   ; YES ->
	JSR     SCAND   ; WAIT FOR KEY...
	BEQ     TTYKB1  ; NO KEY ->
	JSR     SCAND   ; DEBOUNCE KEY
	BEQ     TTYKB1  ; NO KEY ->
;
GETK    JSR     GETKEY
	CMP     #$15    ; >= $15 = ILLEGAL
	BPL     START   ; YES ->
	CMP     #$14
	BEQ     PCCMD   ; DISPLAY PROGRAM COUNTER
	CMP     #$10
	BEQ     ADDRM   ; ADDRESSMODE
	CMP     #$11
	BEQ     DATAM   ; DATAMODE
	CMP     #$12
	BEQ     STEP    ; STEP
	CMP     #$13
	BEQ     GOV	; EXECUTE PROGRAM
DATA    ASL	A	; ONE OF THE HEXIDECIMAL BUTTONS HAS BEEN PUSHED
	ASL	A	; SHIFT CHAR INTO HIGH ORDER NIBBLE
	ASL	A     
	ASL	A
	STA     TEMP    ; STORE FOR DATAMODE
	LDX     #$04
DATA1   LDY     MODE    ; PART OF ADDRESS?
	BNE     ADDR    ; YES ->        --------------------------- PAGE 18 ------
	LDA     (POINTL),Y   ; GET DATA
	ASL     TEMP
	ROL	A       ; MSB-TEMP = MSB-KEY -> A
	STA     (POINTL),Y   ; STORE NEW DATA
	JMP     DATA2
;
ADDR    ASL	A       ; TEMP NOT NEEDED HERE
	ROL     POINTL  ; MSB-KEY -> POINTL
	ROL     POINTH  ; POINTL -> POINTH
DATA2   DEX             ; 4 TIMES = COMPLETE NIBBLE?
	BNE     DATA1   ; NO ->
	BEQ     DATAM2  ; -> ALWAYS
;
ADDRM   LDA     #$01	; SWITCH TO ADDRESS MODE
	BNE     DATAM1  ; -> ALWAYS
;
DATAM   LDA     #$00
DATAM1  STA     MODE
DATAM2  JMP     START
;
STEP    JSR     INCPT	; INCREMENT ADDRESS ON DISPLAY
	JMP     START
;
GOV     JMP     GOEXEC
;
;
; DISPLAY PC BY MOVING
; PC TO POINT
;
PCCMD   LDA     PCL
	STA     POINTL
	LDA     PCH
	STA     POINTH
	JMP     START
;
; LOAD PAPERTAPE FROM TTY
;
LOAD    JSR     GETCH
	CMP     #$3B	; ";" SEMICOLON
	BNE     LOAD	; NO -> AGAIN
LOADS   LDA     #$00
	STA     CHKSUM
	STA     CHKHI
;
	JSR     GETBYT	; GET BYTE CNT
	TAX
	JSR     CHK	; COMPUTE CHECKSUM
	JSR     GETBYT	; GET ADDRESS HI
	STA     POINTH
	JSR     CHK	; COMPUTE CHECKSUM
	JSR     GETBYT	; GET ADDRESS LO
; ---------------------------------------------------------------- PAGE 19 ------
	STA     POINTL
	JSR     CHK     ; COMPUTE CHECKSUM
;
	TXA             ; CNT = 0 ?
	BEQ     LOAD3
;
LOAD2   JSR     GETBYT  ; GET DATA
	STA     (POINTL),Y      ; STORE DATA
	JSR     CHK	; COMPUTE CHECKSUM
	JSR     INCPT
	DEX
	BNE     LOAD2
	INX             ; X=1 = DATA RECORD, X=0 = LAST RECORD
;
LOAD3   JSR     GETBYT  ; COMPARE CHECKSUM
	CMP     CHKHI
	BNE     LOADE1
	JSR     GETBYT
	CMP     CHKSUM
	BNE     LOADER
;
	TXA             ; X=0 = LAST RECORD
	BNE     LOAD
LOAD7   LDX     #$0C    ; X-OFF KIM
LOAD8   LDA     #$27
	STA     SBD     ; DISABLE DATA IN
	JSR     PRTST
	JMP     START
;
LOADE1  JSR     GETBYT  ; DUMMY
LOADER  LDX     #$11    ; X-OFF ERROR KIM
	BNE     LOAD8   ; ALWAYS ->
;
;
; DUMP TO TTY
; FROM OPEN CELL ADDRESS TO LIMHL, LIMHH
;
;
DUMP    LDA     #$00
	STA     INL
	STA     INH     ; CLEAR RECORD COUNT
DUMP0   LDA     #$00
	STA     CHKHI   ; CLEAR CHECKSUM
	STA     CHKSUM
;
DUMP1   JSR     CRLF
	LDA     #$3B    ; ";" SEMICOLON
	JSR     OUTCH
	LDA     POINTL	; CHECK IF POINTL/H >= EAL/H
	CMP     EAL
	LDA     POINTH
	SBC     EAH	; ---------------------------------------- PAGE 20 ------
	BCC     DUMP4   ; NO ->
;
	LDA     #$00    ; PRINT LAST RECORD
	JSR     PRTBYT  ; 0 BYTES
	JSR     OPEN
	JSR     PRTPNT
;
	LDA     CHKHI   ; PRINT CHECKSUM
	JSR     PRTBYT	; DAS IST FALSCH --> PRTPNT  ;  FOR LAST RECORD
	LDA     CHKSUM
	JSR     PRTBYT
	JMP     CLEAR
;
DUMP4   LDA     #$18    ; PRINT 24 BYTES
	TAX             ; SAVE AS INDEX
	JSR     PRTBYT
	JSR     CHK
	JSR     PRTPNT
;
DUMP2   LDY     #$00
	LDA     (POINTL),Y
	JSR     PRTBYT  ; PRINT DATA
	JSR     CHK
	JSR     INCPT
	DEX             ; PRINTED EVERYTHING?
	BNE     DUMP2   ; NO ->
;
	LDA     CHKHI
	JSR     PRTBYT  ; PRINT CHECKSUM
	LDA     CHKSUM
	JSR     PRTBYT
	INC     INL     ; INCREMENT RECOURD COUNTER
	BNE     DUMP3
	INC     INH
DUMP3   JMP     DUMP0
;
SPACE   JSR     OPEN    ; OPEN NEW CELL
SHOW    JSR     CRLF
SHOW1   JSR     PRTPNT
	JSR     OUTSP   ; PRINT SPACE
	LDY     #$00
	LDA     (POINTL),Y      ; PRINT DATA
	JSR     PRTBYT
	JSR     OUTSP   ; PRINT SPACE
	JMP     CLEAR
;
RTRN    JSR     INCPT   ; NEXT ADDRESS
	JMP     SHOW
;
GOEXEC  LDX     SPUSER  ; USER USER DEFINED STACK
	TXS		; START A PROGRAM AT DISPLAYED ADDRESS.
	LDA     POINTH  ; PROGRAM RUNS FROM ---------------------- PAGE 21 ------
	PHA             ; DISPLAYED ADDRESS
	LDA     POINTL
	PHA
	LDA     PREG    ; USER DEFINED FLAG REGISTER
	PHA
	LDX     XREG
	LDY     YREG
	LDA     ACC
	RTI             ; START PROGRAM 
;
SCAN    CMP     #$20    ; OPEN NEW CELL, AKE CARE IF TTY-INPUT
	BEQ     SPACE
	CMP     #$7F    ; RUB OUT, RESTART KIM
	BEQ     STV
	CMP     #$0D    ; NEXT CELL
	BEQ     RTRN
	CMP     #$0A    ; PREV CELL
	BEQ     FEED
	CMP     #$2E    ; "." = MODIFY CELL
	BEQ     MODIFY
	CMP     #$47    ; "G" = EXEC PROGRAM
	BEQ     GOEXEC
	CMP     #$51    ; "Q" = DUMP FROM OPEN CELL
	BEQ     DUMPV   ;  TO HI LIMIT
	CMP     #$4C    ; "L" = LOAD TAPE
	BEQ     LOADV
	JMP     READ    ; IGNORE ILLEGAL CHAR
;
STV     JMP     START
DUMPV   JMP     DUMP
LOADV   JMP     LOAD
;
FEED    SEC
	LDA     POINTL  ; DECREMENT POINTL/H
	SBC     #$01
	STA     POINTL
	BCS     FEED1
	DEC     POINTH
FEED1   JMP     SHOW
;
MODIFY  LDY     #$00    ; GET CONTENTS OF INPUT BUFFER
	LDA     INL     ;  INL AND STORE IN LOCATION
	STA     (POINTL),Y      ;  SPECIFIED BY POINT
	JMP     RTRN
;
; END OF MAIN LINE
; ---------------------------------------------------------------- PAGE 22 ------
;
; SUBROUTINES FOLLOWS
;
;
; SUBROUTINE TO PRINT POINT = ADDRESS
;
PRTPNT  LDA     POINTH
	JSR     PRTBYT
	JSR     CHK
	LDA     POINTL
	JSR     PRTBYT
	JSR     CHK
	RTS
;
; PRINT STRING FROM ASCII CHAR
; FROM TOP+X TO TOP
;
CRLF    LDX     #$07    ; OUTPUT <RETURN> AND <LF>
PRTST   LDA     TOP,X
	JSR     OUTCH
	DEX             ; EVERYTHING?
	BPL     PRTST   ; NO ->
PRT1    RTS
;
; PRINT 1 HEX BYTE AS 2 ASCII CHARS
;
PRTBYT  STA     TEMP    ; SAVE A
	LSR	A       ; SHIFT A 4 TIMES
	LSR	A
	LSR	A
	LSR	A
	JSR     HEXTA   ; CONVERT BIT 4..7 TO HEX AND PRINT
	LDA     TEMP
	JSR     HEXTA   ; CONVERT BIT 0..7 TO HEX AND PRINT
	LDA     TEMP    ; RESTORE A
	RTS
;
HEXTA   AND     #$0F    ; MASK BIT 0..4
	CMP     #$0A    ; > 10 ?
	CLC
	BMI     HEXTA1  ; NO ->
	ADC     #$07    ; A..F
HEXTA1  ADC     #$30    ; CONVERT TO ASCII-CHAR...
	JMP     OUTCH   ;  ...AND PRINT IT
;
; GET CHAR FROM TTY IN A
; RETURN FROM SUB WITH CHAR IN A
; X IS PRESERVED AND Y RETURNED = FF
;
GETCH   STX     TMPX	; TTY INPUT ROUTINE USED BY MICROSOFT BASIC, VER. KB9, 1978
	LDX     #$08    ; COUNT 8 BITS
	LDA     #$01	; ---------------------------------------- PAGE 23 ------
GET1    BIT     SAD     ; CHECK IF STILL IN TTY-MODE
	BNE     GET6    ; IF NOT THEN DO NOTHING AND RETURN
	BMI     GET1    ; WAIT FOR STARTBIT, PA7 IS INPUT TTY
	JSR     DELAY   ; DELAY 1 BITBY DELAYING ANOTHER HALF BIT TIME, YOU READ THE BIT IN THE MIDDLE OF EVERY BIT.
GET5    JSR     DEHALF  ; DELAY 1/2 BIT TIME 
GET2    LDA     SAD
	AND     #$80    ; MASK BIT 7
	LSR     CHAR    ; SHIFT LAST RESULT
	ORA     CHAR    ; OR IT WITH NEW BIT
	STA     CHAR    ; AND STORE IT AGAIN
	JSR     DELAY
	DEX
	BNE     GET2    ; NEXT BIT
	JSR     DEHALF  ; WHY ????
;
	LDX     TMPX
	LDA     CHAR
	ROL     A       ; SHIFT OFF STOPBIT
	LSR	A
GET6    RTS
;
; INITIALIZATION FOR SIGMA 6530   $1E88
;
INITS   LDX     #$01    ; SET DISPLAY TO ADDRESS MODE
	STX     MODE
;
INIT1   LDX     #$00
	STX     PADD    ; PA0..PA7 = INPUT
	LDX     #$3F
	STX     PBDD    ; PB0..PB5 = OUTPUT
			; PB6, PB7 = INPUT
	LDX     #$07    ; SET 74145 OUTPUT OPEN-COLLETOR Q3 (ROW 3) TO LOW TO CHECK KB/TTY MODE.
	STX     SBD     ; TTY MODE WHEN EXPANSION CONNECTOR PINS A-V & A-21 ARE CONNECTED.
	CLD		; THIS CONNECTS 74145 OC OUTPUT Q3 (PIN 4) WITH PORT PA0 (PIN2), ACTING AS INPUT.
	SEI
	RTS
;
; OUTPUT CHAR IN A TO TTY       $1E9E
;
;
OUTSP   LDA     #$20    ; PRINT SPACE
OUTCH   STA     CHAR	; TTY OUTPUT ROUTINE USED BY MICROSOFT BASIC, VER. KB9, 1978
	STX     TMPX
	JSR     DELAY
	LDA     SBD	; READ PORT TO ENSURE THAT OTHER OUTPUT PINS OF PORTS ARE NOT CHANGED !
	AND     #$FE    ; SEND STARTBIT
	STA     SBD     ; PB0 = 0 -> TTY = 1 (H) BECAUSE OF 7438 U26C NAND GATE
	JSR     DELAY
	LDX     #$08    ; SEND CHARACTER
OUT1    LDA     SBD
	AND     #$FE    ; CLEAR BIT 0
	LSR     CHAR    ; SHIFT BYTE TO RIGHT, BIT 0 THEN GOES TO CARRY BIT
	ADC     #$00    ; ADD CARRY = FORMER BIT 0, THEN BIT 0 IS THE BIT TO SEND -- PAGE 24 ------
	STA     SBD     ; OUTPUT BIT
	JSR     DELAY
	DEX             ; ALL BITS?
	BNE     OUT1    ; NO ->
	LDA     SBD
	ORA     #$01
	STA     SBD     ; STOP BIT, PB0 = 1 --> TTY = 0 (L) BECAUSE OF 7438 U26C NAND GATE
	JSR     DELAY
	LDX     TMPX
	RTS
;
; DELAY 1 BIT TIME AS DETERMINED BY DETCPS
;
;
DELAY   LDA     CNTH30
	STA     TIMH
	LDA     CNTL30
DE2     SEC
DE4     SBC     #$01
	BCS     DE3     ; A <> $FF ->
	DEC     TIMH
DE3     LDY     TIMH    ; TIMH > 0 ?
	BPL     DE2     ; YES ->
	RTS
;
; DELAY HALF A BIT TIME
DEHALF  LDA     CNTH30
	STA     TIMH
	LDA     CNTL30
	LSR	A
	LSR     TIMH
	BCC     DE2

	ORA     #$80
	BCS     DE4     ; ALWAYS ->
;
; DETERMINE IF KEY IS DEPRESSED: NO -> A=0, YES -> A > 0
; DEPRESSED OR CONDITION OF SSW
;	 KEY NOT DEPRESSED OR TTY MODE: A = 0
;	 KEY DEPRESSED OR KB MODE: A NOT ZERO
;
AK      LDY     #$03    ; 3 ROWS
	LDX     #$01    ; SELECT 74145 OUTPUT Q0

ONEKEY  LDA     #$FF    ; INITIAL VALUE
AK1     STX     SBD     ; ENABLE OUTPUT = SELECT ROW
	INX
	INX             ; PREPARE FOR NEXT ROW
	AND     SAD     ; A := A && (PA0..PA7)
	DEY             ; ALL ROWS?
	BNE     AK1     ; NO ->
; ---------------------------------------------------------------- PAGE 25 ------
	LDY     #$07
	STY     SBD     ; SELECT 74145 OUTPUT 3 (NOT USED)
;
	ORA     #$80    ; MASK BIT 7 OF A
	EOR     #$FF    ; IF A STILL IS $FF -> A := 0
	RTS
;
; OUTPUT TO 7-SEGMENT-DISPLAY
;
SCAND   LDY     #$00     ; POINTL/POINTH = ADDRESS ON DISPLAY
	LDA     (POINTL),Y      ; GET DATA FROM THIS ADDRESS
	STA     INH     ; STORE IN INH = 
SCANDS  LDA     #$7F    ; PA0..PA6 := OUTPUT
	STA     PADD

	LDX     #$09    ; START WITH DISPLAY AT OUTPUT 4
	LDY     #$03    ; 3 BYTES TO BE SHOWN
;
SCAND1  LDA     INL,Y   ; GET BYTE
	LSR	A       ; GET MSD BY SHIFTING A
	LSR	A
	LSR	A
	LSR	A
	JSR     CONVD
	LDA     INL,Y   ; GET BYTE AGAIN
	AND     #$0F    ; GET LSD
	JSR     CONVD
	DEY             ; ALL ?
	BNE     SCAND1  ; NO ->

	STX     SBD     ; ALL DIGITS OFF
	LDA     #$00
	STA     PADD    ; PA0..PA7 := INPUT
	JMP     AK
;
; CONVERT DIGIT INTO 7-SEGMENT-VALUE
;
CONVD   STY     TEMP
	TAY
	LDA     TABLE,Y
	LDY     #$00
	STY     SAD     ; TURN OFF SEGMENTS
	STX     SBD     ; SELECT 7 SEGMENT DISPLAY
	STA     SAD     ; OUTPUT CODE ON DISPLAY
	LDY     #$7F    ; DELAY 508 PHI2 CLOCK CYCLES (508 MICROSEC)
CONVD1  DEY
	BNE     CONVD1
;
;
	INX             ; NEXT DISPLAY
	INX		; ---------------------------------------- PAGE 26 ------
	LDY     TEMP
	RTS
;
; INCREMENT POINT = ADDRESS ON DISPLAY
;
INCPT   INC     POINTL
	BNE     INCPT2

	INC     POINTH
INCPT2  RTS
;
; GET KEY FROM KEYBOARD
; RETURN WITH A=KEY
; A > 15 -> ILLEGAL OR NO KEY
;
GETKEY  LDX     #$21    ; ROW 0 / DISABLE INPUT TTY
GETKE5  LDY     #$01    ; ONLY ONE ROW IN THE TIME
	JSR     ONEKEY  ; KEY?
	BNE     KEYIN   ; YES ->
	CPX     #$27    ; LAST ROW?
	BNE     GETKE5  ; NO, NEXT ONE ->
	LDA     #$15    ; 15 = NO KEY
	RTS
KEYIN   LDY     #$FF    ; Y := KEY NUMBER
KEYIN1  ASL	A       ; SHIFT A UNTIL
	BCS     KEYIN2  ;  BIT = 1 -> ; COMMENT: BIT 7 IS ALWAYS 0 SO CARRY IS ALWAYS 0 THE FIRST TIME
	INY     	;  AND ALLOWING Y TO BECOME 0 (KEY $FF DOES NOT EXIST)
	BPL     KEYIN1  ; ALWAYS ->
KEYIN2  TXA
	AND     #$0F    ; STRIP BIT4..7
	LSR	A       ; A := ROW+1
	TAX             ; X := ACTUAL ROW+1
	TYA
	BPL     KEYIN4  ; ALWAYS, BECAUSE Y<7 -> ; ADD 7 TO A FOR EVERY ROW ABOVE 0 TO GET ACTUAL KEY NUMBER
KEYIN3  CLC
	ADC     #$07    ; ADD (X-1) TIMES 7 TO A
KEYIN4  DEX             ; COUNTDOWN TO 0
	BNE     KEYIN3  
	RTS             ; A IS ALWAYS < 21 EG. < $15
;
; COMPUTE CHECKSUM, USED FOR PAPERTAPE LOAD/DUMP
;
CHK     CLC
	ADC     CHKSUM
	STA     CHKSUM
	LDA     CHKHI
	ADC     #$00
	STA     CHKHI
	RTS
; GET 2 HEX-CHARS AND PACK INTO INL AND INH
;  NON HEX CHAR WILL BE LOADED AS NEAREST HEX EQUIVALENT
;
; ---------------------------------------------------------------- PAGE 27 ------
;
;
GETBYT  JSR     GETCH
	JSR     PACK
	JSR     GETCH
	JSR     PACK
	LDA     INL
	RTS
;
; SHIFT CHAR IN A INTO INL AND INH
;
PACK    CMP     #$30    ; IS HEX?
	BMI     UPDAT2  ; < = NO ->
	CMP     #$47
	BPL     UPDAT2  ; > = NO ->
HEXNUM  CMP     #$40    ; A..F ?
	BMI     UPDATE  ; NO ->
HEXALP  CLC
	ADC     #$09
UPDATE  ROL	A       ; SHIFT TO BIT 4..7
	ROL	A
	ROL	A
	ROL	A
	LDY     #$04    ; SHIFT INTO INL/INH
UPDAT1  ROL	A
	ROL     INL
	ROL     INH
	DEY     ; 4 TIMES ?
	BNE     UPDAT1  ; NO ->

	LDA     #$00    ; IF HEX NUMBER -> A := 0
UPDAT2  RTS
;
OPEN    LDA     INL     ; MOVE I/O-BUFFER TO POINT
	STA     POINTL
	LDA     INH
	STA     POINTH
	RTS
;
; END OF SUBROUTINES
; ---------------------------------------------------------------- PAGE 28 ------
; TABLES
;
TOP     .BYTE     $00,$00,$00,$00,$00,$00,$0A,$0D,"MIK" ; ONLY USED IN FUNCTION CRLF/PRTEST
	.BYTE     " ",$13,"RRE"," ",$13 ; ONLY USED AT SYMBOL LOAD7 WITH LDX = #$0C (LOAD PAPERTAPE)
;
; TABLE HEX TO 7 SEGMENT
;		0   1   2   3   4   5   6   7
TABLE   .BYTE	$BF,$86,$DB,$CF,$E6,$ED,$FD,$87
;		8   9   A   B   C   D   E   F
	.BYTE	$FF,$EF,$F7,$FC,$B9,$DE,$F9,$F1
;
; LAST PSEUDO OPCODE (.BYTE) SHALL RESULT IN ADDRESS AND CODE: 1FF5   F9 F1    
;
; INTERRUPT VECTORS
;
	*=$1FFA
NMIENT  .WORD     NMIT
RSTENT  .WORD     RST
IRQENT  .WORD     IRQT
;
; END OF SOURCE CODE
;