/*******************************************************
 Author:					Manfred Langemann
 mailto:					Manfred.Langemann t t-online.de
 Begin of project:			21.11.2020
 Latest version generated:	12.12.2020
 Filename:					General.h
 Description:				Include file all ATmega files
 ********************************************************/
#ifndef _GENERAL
#define _GENERAL

#define	TRUE	1
#define	FALSE	0
/*
 !!!!!!!!!!!!!!!!!!!!!!!!! WARNING !!!!!!!!!!!!!!!!!!!!!!!!!!
 Do not place any printf() statements to the code,
 because the content will be sent to the PC via the RS232 to USB line.
 But the PC program does not understand this,
 because it only interprets data in form of binary command confirmations and EEPROM data.
 !!!!!!!!!!!!!!!!!!!!!!!!! WARNING !!!!!!!!!!!!!!!!!!!!!!!!!!
*/
/*
** To exclude all printf() statements in release version, use "#define RELEASE"
*/
//#define RELEASE
#ifdef RELEASE
#define printf(...)
#endif

/*
** Here are some definitions, used in all programs
*/
#ifndef F_CPU
#define F_CPU       10000000 // processor clock frequency = 10 MHz with external crystal
#endif
#define SYSCLOCK	F_CPU	// Crystal Frequency in Hz

#define SET_BIT(PORT, BITNUM)	((PORT) |= (1<<(BITNUM)))
#define CLEAR_BIT(PORT, BITNUM) ((PORT) &= ~(1<<(BITNUM)))
#define TOOGLE_BIT(PORT,BITNUM) ((PORT) ^= (1<<(BITNUM)))

struct BitsOfByte 
	{
	uint8_t b0:1;
	uint8_t b1:1;
	uint8_t b2:1;
	uint8_t b3:1;
	uint8_t b4:1;
	uint8_t b5:1;
	uint8_t b6:1;
	uint8_t b7:1;
	} __attribute__((__packed__));


#define SBIT(port,pin) ((*(volatile struct BitsOfByte*)&port).b##pin)

#endif	// _GENERAL
